diff --git a/grub-core/loader/i386/xen_fileXX.c b/grub-core/loader/i386/xen_fileXX.c
new file mode 100644
index 0000000..ea0656c
--- /dev/null
+++ b/grub-core/loader/i386/xen_fileXX.c
@@ -0,0 +1,344 @@
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2013  Free Software Foundation, Inc.
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <grub/xen_file.h>
+
+static grub_err_t
+parse_xen_guest (grub_elf_t elf, struct grub_xen_file_info *xi,
+		 grub_off_t off, grub_size_t sz)
+{
+  char *buf;
+  char *ptr;
+  int has_paddr = 0;
+  if (grub_file_seek (elf->file, off) == (grub_off_t) -1)
+    return grub_errno;
+  buf = grub_malloc (sz);
+  if (!buf)
+    return grub_errno;
+
+  if (grub_file_read (elf->file, buf, sz) != (grub_ssize_t) sz)
+    {
+      if (grub_errno)
+	return grub_errno;
+      return grub_error (GRUB_ERR_BAD_OS, N_("premature end of file %s"),
+			 elf->file->name);
+    }
+  xi->has_xen_guest = 1;
+  for (ptr = buf; ptr && ptr - buf < (grub_ssize_t) sz;
+       ptr = grub_strchr (ptr, ','), (ptr ? ptr++ : 0))
+    {
+      if (grub_strncmp (ptr, "PAE=no,", sizeof ("PAE=no,") - 1) == 0)
+	{
+	  if (xi->arch != GRUB_XEN_FILE_I386
+	      && xi->arch != GRUB_XEN_FILE_I386_PAE
+	      && xi->arch != GRUB_XEN_FILE_I386_PAE_BIMODE)
+	    continue;
+	  xi->arch = GRUB_XEN_FILE_I386;
+	  continue;
+	}
+
+      if (grub_strncmp (ptr, "PAE=yes,", sizeof ("PAE=yes,") - 1) == 0)
+	{
+	  if (xi->arch != GRUB_XEN_FILE_I386
+	      && xi->arch != GRUB_XEN_FILE_I386_PAE
+	      && xi->arch != GRUB_XEN_FILE_I386_PAE_BIMODE)
+	    continue;
+	  xi->arch = GRUB_XEN_FILE_I386_PAE;
+	  continue;
+	}
+
+      if (grub_strncmp (ptr, "PAE=yes[extended-cr3],",
+			sizeof ("PAE=yes[extended-cr3],") - 1) == 0)
+	{
+	  if (xi->arch != GRUB_XEN_FILE_I386
+	      && xi->arch != GRUB_XEN_FILE_I386_PAE
+	      && xi->arch != GRUB_XEN_FILE_I386_PAE_BIMODE)
+	    continue;
+	  xi->arch = GRUB_XEN_FILE_I386_PAE;
+	  xi->extended_cr3 = 1;
+	  continue;
+	}
+
+      if (grub_strncmp (ptr, "PAE=bimodal,", sizeof ("PAE=bimodal,") - 1) == 0)
+	{
+	  if (xi->arch != GRUB_XEN_FILE_I386
+	      && xi->arch != GRUB_XEN_FILE_I386_PAE
+	      && xi->arch != GRUB_XEN_FILE_I386_PAE_BIMODE)
+	    continue;
+	  xi->arch = GRUB_XEN_FILE_I386_PAE_BIMODE;
+	  continue;
+	}
+
+      if (grub_strncmp (ptr, "PAE=bimodal[extended-cr3],",
+			sizeof ("PAE=bimodal[extended-cr3],") - 1) == 0)
+	{
+	  if (xi->arch != GRUB_XEN_FILE_I386
+	      && xi->arch != GRUB_XEN_FILE_I386_PAE
+	      && xi->arch != GRUB_XEN_FILE_I386_PAE_BIMODE)
+	    continue;
+	  xi->arch = GRUB_XEN_FILE_I386_PAE_BIMODE;
+	  xi->extended_cr3 = 1;
+	  continue;
+	}
+
+      if (grub_strncmp (ptr, "PAE=yes,bimodal,", sizeof ("PAE=yes,bimodal,") - 1) == 0)
+	{
+	  if (xi->arch != GRUB_XEN_FILE_I386
+	      && xi->arch != GRUB_XEN_FILE_I386_PAE
+	      && xi->arch != GRUB_XEN_FILE_I386_PAE_BIMODE)
+	    continue;
+	  xi->arch = GRUB_XEN_FILE_I386_PAE_BIMODE;
+	  continue;
+	}
+
+      if (grub_strncmp (ptr, "PAE=yes[extended-cr3],bimodal,",
+			sizeof ("PAE=yes[extended-cr3],bimodal,") - 1) == 0)
+	{
+	  if (xi->arch != GRUB_XEN_FILE_I386
+	      && xi->arch != GRUB_XEN_FILE_I386_PAE
+	      && xi->arch != GRUB_XEN_FILE_I386_PAE_BIMODE)
+	    continue;
+	  xi->arch = GRUB_XEN_FILE_I386_PAE_BIMODE;
+	  xi->extended_cr3 = 1;
+	  continue;
+	}
+
+      if (grub_strncmp (ptr, "VIRT_BASE=", sizeof ("VIRT_BASE=") - 1) == 0)
+	{
+	  xi->virt_base = grub_strtoull (ptr + sizeof ("VIRT_BASE=") - 1, &ptr, 16);
+	  if (grub_errno)
+	    return grub_errno;
+	  continue;
+	}
+      if (grub_strncmp (ptr, "VIRT_ENTRY=", sizeof ("VIRT_ENTRY=") - 1) == 0)
+	{
+	  xi->entry_point = grub_strtoull (ptr + sizeof ("VIRT_ENTRY=") - 1, &ptr, 16);
+	  if (grub_errno)
+	    return grub_errno;
+	  continue;
+	}
+      if (grub_strncmp (ptr, "HYPERCALL_PAGE=", sizeof ("HYPERCALL_PAGE=") - 1) == 0)
+	{
+	  xi->hypercall_page = grub_strtoull (ptr + sizeof ("HYPERCALL_PAGE=") - 1, &ptr, 16);
+	  xi->has_hypercall_page = 1;
+	  if (grub_errno)
+	    return grub_errno;
+	  continue;
+	}
+      if (grub_strncmp (ptr, "ELF_PADDR_OFFSET=", sizeof ("ELF_PADDR_OFFSET=") - 1) == 0)
+	{
+	  xi->paddr_offset = grub_strtoull (ptr + sizeof ("ELF_PADDR_OFFSET=") - 1, &ptr, 16);
+	  has_paddr = 1;
+	  if (grub_errno)
+	    return grub_errno;
+	  continue;
+	}
+    }
+  if (xi->has_hypercall_page)
+    xi->hypercall_page = (xi->hypercall_page << 12) + xi->virt_base;
+  if (!has_paddr)
+    xi->paddr_offset = xi->virt_base;
+  return GRUB_ERR_NONE;
+}
+
+static grub_err_t
+parse_note (grub_elf_t elf, struct grub_xen_file_info *xi,
+	    grub_off_t off, grub_size_t sz)
+{
+  grub_uint32_t *buf;
+  grub_uint32_t *ptr;
+  if (grub_file_seek (elf->file, off) == (grub_off_t) -1)
+    return grub_errno;
+  buf = grub_malloc (sz);
+  if (!buf)
+    return grub_errno;
+
+  if (grub_file_read (elf->file, buf, sz) != (grub_ssize_t) sz)
+    {
+      if (grub_errno)
+	return grub_errno;
+      return grub_error (GRUB_ERR_BAD_OS, N_("premature end of file %s"),
+			 elf->file->name);
+    }
+  for (ptr = buf; ptr - buf < (grub_ssize_t) (sz / sizeof (grub_uint32_t));)
+    {
+      Elf_Nhdr *nh = (Elf_Nhdr *) ptr;
+      char *name;
+      grub_uint32_t *desc;
+      grub_uint32_t namesz, descsz;
+      ptr += sizeof (*nh) / sizeof (grub_uint32_t);
+      name = (char *) ptr;
+      namesz = grub_le_to_cpu32 (nh->n_namesz);
+      descsz = grub_le_to_cpu32 (nh->n_descsz);
+      ptr += (namesz + 3) / 4;
+      desc = ptr;
+      ptr += (grub_le_to_cpu32 (nh->n_descsz) + 3) / 4;
+      if ((namesz < 3) || grub_memcmp (name, "Xen", namesz == 3 ? 3 : 4) != 0)
+	continue;
+      xi->has_note = 1;
+      switch (nh->n_type)
+	{
+	case 1:
+	  xi->entry_point = grub_le_to_cpu_addr (*(Elf_Addr *) desc);
+	  break;
+	case 2:
+	  xi->hypercall_page = grub_le_to_cpu_addr (*(Elf_Addr *) desc);
+	  xi->has_hypercall_page = 1;
+	  break;
+	case 3:
+	  xi->virt_base = grub_le_to_cpu_addr (*(Elf_Addr *) desc);
+	  break;
+	case 4:
+	  xi->paddr_offset = grub_le_to_cpu_addr (*(Elf_Addr *) desc);
+	  break;
+	case 5:
+	  grub_dprintf ("xen", "xenversion = `%s'\n", (char *) desc);
+	  break;
+	case 6:
+	  grub_dprintf ("xen", "name = `%s'\n", (char *) desc);
+	  break;
+	case 7:
+	  grub_dprintf ("xen", "version = `%s'\n", (char *) desc);
+	  break;
+	case 8:
+	  if (descsz < 7
+	      || grub_memcmp (desc, "generic", descsz == 7 ? 7 : 8) != 0)
+	    return grub_error (GRUB_ERR_BAD_OS, "invalid loader");
+	  break;
+	  /* PAE */
+	case 9:
+	  grub_dprintf ("xen", "pae = `%s', %d, %d\n", (char *) desc,
+			xi->arch, descsz);
+	  if (xi->arch != GRUB_XEN_FILE_I386
+	      && xi->arch != GRUB_XEN_FILE_I386_PAE
+	      && xi->arch != GRUB_XEN_FILE_I386_PAE_BIMODE)
+	    break;
+	  if (descsz >= 3 && grub_memcmp (desc, "yes",
+					  descsz == 3 ? 3 : 4) == 0)
+	    {
+	      xi->extended_cr3 = 1;
+	      xi->arch = GRUB_XEN_FILE_I386_PAE;
+	    }
+	  if (descsz >= 7 && grub_memcmp (desc, "bimodal",
+					  descsz == 7 ? 7 : 8) == 0)
+	    {
+	      xi->extended_cr3 = 1;
+	      xi->arch = GRUB_XEN_FILE_I386_PAE_BIMODE;
+	    }
+	  if (descsz >= 11 && grub_memcmp (desc, "yes,bimodal",
+					   descsz == 11 ? 11 : 12) == 0)
+	    {
+	      xi->extended_cr3 = 1;
+	      xi->arch = GRUB_XEN_FILE_I386_PAE_BIMODE;
+	    }
+	  if (descsz >= 2 && grub_memcmp (desc, "no",
+					  descsz == 2 ? 2 : 3) == 0)
+	    xi->arch = GRUB_XEN_FILE_I386;
+	  break;
+	default:
+	  grub_dprintf ("xen", "unknown note type %d\n", nh->n_type);
+	  break;
+	}
+    }
+  return GRUB_ERR_NONE;
+}
+
+grub_err_t
+grub_xen_get_infoXX (grub_elf_t elf, struct grub_xen_file_info *xi)
+{
+  Elf_Shdr *s, *s0;
+  grub_size_t shnum = elf->ehdr.ehdrXX.e_shnum;
+  grub_size_t shentsize = elf->ehdr.ehdrXX.e_shentsize;
+  grub_size_t shsize = shnum * shentsize;
+  grub_off_t stroff;
+  grub_err_t err;
+  Elf_Phdr *phdr;
+
+  xi->kern_end = 0;
+  xi->kern_start = ~0;
+  xi->entry_point = elf->ehdr.ehdrXX.e_entry;
+
+  /* FIXME: check note.  */
+  FOR_ELF_PHDRS (elf, phdr)
+    {
+      Elf_Addr paddr;
+
+      if (phdr->p_type == PT_NOTE)
+	{
+	  err = parse_note (elf, xi, phdr->p_offset, phdr->p_filesz);
+	  if (err)
+	    return err;
+	}
+
+      if (phdr->p_type != PT_LOAD)
+	continue;
+
+      paddr = phdr->p_paddr;
+
+      if (paddr < xi->kern_start)
+	xi->kern_start = paddr;
+
+      if (paddr + phdr->p_memsz > xi->kern_end)
+	xi->kern_end = paddr + phdr->p_memsz;
+    }
+
+  if (xi->has_note)
+    return GRUB_ERR_NONE;
+
+  if (!shnum || !shentsize)
+    return grub_error (GRUB_ERR_BAD_OS, "no XEN note");
+
+  s0 = grub_malloc (shsize);
+  if (!s0)
+    return grub_errno;
+
+  if (grub_file_seek (elf->file, elf->ehdr.ehdrXX.e_shoff) == (grub_off_t) -1)
+    return grub_errno;
+
+  if (grub_file_read (elf->file, s0, shsize) != (grub_ssize_t) shsize)
+    {
+      if (grub_errno)
+	return grub_errno;
+      return grub_error (GRUB_ERR_BAD_OS, N_("premature end of file %s"),
+			 elf->file->name);
+    }
+
+  s = (Elf_Shdr *) ((char *) s0 + elf->ehdr.ehdrXX.e_shstrndx * shentsize);
+  stroff = s->sh_offset;
+
+  for (s = s0; s < (Elf_Shdr *) ((char *) s0 + shnum * shentsize);
+       s = (Elf_Shdr *) ((char *) s + shentsize))
+    {
+      char name[sizeof("__xen_guest")];
+      grub_memset (name, 0, sizeof (name));
+      if (grub_file_seek (elf->file, stroff + s->sh_name) == (grub_off_t) -1)
+	return grub_errno;
+
+      if (grub_file_read (elf->file, name, sizeof (name)) != (grub_ssize_t) sizeof (name))
+	{
+	  if (grub_errno)
+	    return grub_errno;
+	  continue;
+	}
+      if (grub_memcmp (name, "__xen_guest",
+		       sizeof("__xen_guest")) != 0)
+	continue;
+      return parse_xen_guest (elf, xi, s->sh_offset, s->sh_size);
+    }
+  return grub_error (GRUB_ERR_BAD_OS, "no XEN note found");
+}
diff --git a/grub-core/term/xen/console.c b/grub-core/term/xen/console.c
new file mode 100644
index 0000000..a1f15f7
--- /dev/null
+++ b/grub-core/term/xen/console.c
@@ -0,0 +1,122 @@
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2011  Free Software Foundation, Inc.
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <grub/term.h>
+#include <grub/types.h>
+#include <grub/misc.h>
+#include <grub/mm.h>
+#include <grub/time.h>
+#include <grub/terminfo.h>
+#include <grub/xen.h>
+
+static int
+readkey (struct grub_term_input *term __attribute__ ((unused)))
+{
+  grub_size_t prod, cons;
+  int r;
+  mb ();
+  prod = grub_xen_xcons->in_prod;
+  cons = grub_xen_xcons->in_cons;
+  if (prod <= cons)
+    return -1;
+  r = grub_xen_xcons->in[cons];
+  cons++;
+  mb ();
+  grub_xen_xcons->in_cons = cons;
+  return r;
+}
+
+static int signal_sent = 1;
+
+static void
+refresh (struct grub_term_output *term __attribute__ ((unused)))
+{
+  struct evtchn_send send;
+  send.port = grub_xen_start_page_addr->console.domU.evtchn;
+  grub_xen_event_channel_op (EVTCHNOP_send, &send);
+  signal_sent = 1;
+  while (grub_xen_xcons->out_prod != grub_xen_xcons->out_cons)
+    {
+      grub_xen_sched_op (SCHEDOP_yield, 0);
+    }
+}
+
+static void
+put (struct grub_term_output *term __attribute__ ((unused)), const int c)
+{
+  grub_size_t prod, cons;
+
+  while (1)
+    {
+      mb ();
+      prod = grub_xen_xcons->out_prod;
+      cons = grub_xen_xcons->out_cons;
+      if (prod < cons + sizeof (grub_xen_xcons->out))
+	break;
+      if (!signal_sent)
+	refresh (term);
+      grub_xen_sched_op (SCHEDOP_yield, 0);
+    }
+  grub_xen_xcons->out[prod++ & (sizeof (grub_xen_xcons->out) - 1)] = c;
+  mb ();
+  grub_xen_xcons->out_prod = prod;
+  signal_sent = 0;
+}
+
+
+struct grub_terminfo_input_state grub_console_terminfo_input = {
+  .readkey = readkey
+};
+
+struct grub_terminfo_output_state grub_console_terminfo_output = {
+  .put = put,
+  .size = {80, 24}
+};
+
+static struct grub_term_input grub_console_term_input = {
+  .name = "console",
+  .init = 0,
+  .getkey = grub_terminfo_getkey,
+  .data = &grub_console_terminfo_input
+};
+
+static struct grub_term_output grub_console_term_output = {
+  .name = "console",
+  .init = 0,
+  .putchar = grub_terminfo_putchar,
+  .getxy = grub_terminfo_getxy,
+  .getwh = grub_terminfo_getwh,
+  .gotoxy = grub_terminfo_gotoxy,
+  .cls = grub_terminfo_cls,
+  .refresh = refresh,
+  .setcolorstate = grub_terminfo_setcolorstate,
+  .setcursor = grub_terminfo_setcursor,
+  .flags = GRUB_TERM_CODE_TYPE_ASCII,
+  .data = &grub_console_terminfo_output,
+};
+
+
+void
+grub_console_init (void)
+{
+  grub_term_register_input ("console", &grub_console_term_input);
+  grub_term_register_output ("console", &grub_console_term_output);
+
+  grub_terminfo_init ();
+  grub_terminfo_output_register (&grub_console_term_output, "vt100-color");
+}
diff --git a/include/grub/disk.h b/include/grub/disk.h
index 096173d..61512c1 100644
--- a/include/grub/disk.h
+++ b/include/grub/disk.h
@@ -41,6 +41,7 @@ enum grub_disk_dev_id
     GRUB_DISK_DEVICE_CRYPTODISK_ID,
     GRUB_DISK_DEVICE_ARCDISK_ID,
     GRUB_DISK_DEVICE_HOSTDISK_ID,
+    GRUB_DISK_DEVICE_XEN,
   };
 
 struct grub_disk;
diff --git a/include/grub/elf.h b/include/grub/elf.h
index 9a75b52..3d8563f 100644
--- a/include/grub/elf.h
+++ b/include/grub/elf.h
@@ -2335,7 +2335,9 @@ typedef Elf32_Addr Elf32_Conflict;
 #if GRUB_TARGET_WORDSIZE == 32
 
 typedef Elf32_Addr Elf_Addr;
+typedef Elf32_Nhdr Elf_Nhdr;
 typedef Elf32_Ehdr Elf_Ehdr;
+typedef Elf32_Phdr Elf_Phdr;
 typedef Elf32_Half Elf_Half;
 typedef Elf32_Off Elf_Off;
 typedef Elf32_Rel Elf_Rel;
@@ -2358,7 +2360,9 @@ typedef Elf32_Xword Elf_Xword;
 #elif GRUB_TARGET_WORDSIZE == 64
 
 typedef Elf64_Addr Elf_Addr;
+typedef Elf64_Nhdr Elf_Nhdr;
 typedef Elf64_Ehdr Elf_Ehdr;
+typedef Elf64_Phdr Elf_Phdr;
 typedef Elf64_Half Elf_Half;
 typedef Elf64_Off Elf_Off;
 typedef Elf64_Rel Elf_Rel;
diff --git a/include/grub/file.h b/include/grub/file.h
index e08ac2e..c1e1c9d 100644
--- a/include/grub/file.h
+++ b/include/grub/file.h
@@ -127,4 +127,10 @@ grub_file_seekable (const grub_file_t file)
   return !file->not_easily_seekable;
 }
 
+grub_file_t
+grub_file_offset_open (grub_file_t parent, grub_off_t start,
+		       grub_off_t size);
+void
+grub_file_offset_close (grub_file_t file);
+
 #endif /* ! GRUB_FILE_HEADER */
diff --git a/include/grub/i386/xen/hypercall.h b/include/grub/i386/xen/hypercall.h
new file mode 100644
index 0000000..0152b2b
--- /dev/null
+++ b/include/grub/i386/xen/hypercall.h
@@ -0,0 +1,85 @@
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2013  Free Software Foundation, Inc.
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef GRUB_XEN_CPU_HYPERCALL_HEADER
+#define GRUB_XEN_CPU_HYPERCALL_HEADER 1
+
+#include <grub/types.h>
+
+int
+EXPORT_FUNC (grub_xen_hypercall) (grub_uint32_t callno, grub_uint32_t a0,
+				  grub_uint32_t a1, grub_uint32_t a2,
+				  grub_uint32_t a3, grub_uint32_t a4,
+				  grub_uint32_t a5)
+__attribute__ ((regparm (3), stdcall));
+
+static inline int
+grub_xen_sched_op (int cmd, void *arg)
+{
+  return grub_xen_hypercall (__HYPERVISOR_sched_op, cmd, (grub_uint32_t) arg,
+			     0, 0, 0, 0);
+}
+
+static inline int
+grub_xen_mmu_update (const struct mmu_update *reqs,
+		     unsigned count, unsigned *done_out, unsigned foreigndom)
+{
+  return grub_xen_hypercall (__HYPERVISOR_mmu_update, (grub_uint32_t) reqs,
+			     (grub_uint32_t) count, (grub_uint32_t) done_out,
+			     (grub_uint32_t) foreigndom, 0, 0);
+}
+
+static inline int
+grub_xen_mmuext_op (mmuext_op_t * ops,
+		    unsigned int count,
+		    unsigned int *pdone, unsigned int foreigndom)
+{
+  return grub_xen_hypercall (__HYPERVISOR_mmuext_op, (grub_uint32_t) ops,
+			     count, (grub_uint32_t) pdone, foreigndom, 0, 0);
+}
+
+static inline int
+grub_xen_event_channel_op (int op, void *arg)
+{
+  return grub_xen_hypercall (__HYPERVISOR_event_channel_op, op,
+			     (grub_uint32_t) arg, 0, 0, 0, 0);
+}
+
+
+static inline int
+grub_xen_update_va_mapping (void *addr, uint64_t pte, uint32_t flags)
+{
+  return grub_xen_hypercall (__HYPERVISOR_update_va_mapping,
+			     (grub_uint32_t) addr, pte, pte >> 32, flags, 0,
+			     0);
+}
+
+static inline int
+grub_xen_grant_table_op (int a, void *b, int c)
+{
+  return grub_xen_hypercall (__HYPERVISOR_grant_table_op, a,
+			     (grub_uint32_t) b, c, 0, 0, 0);
+}
+
+static inline int
+grub_xen_vm_assist (int cmd, int type)
+{
+  return grub_xen_hypercall (__HYPERVISOR_vm_assist, cmd, type, 0, 0, 0, 0);
+}
+
+#endif
diff --git a/include/grub/kernel.h b/include/grub/kernel.h
index 6df2140..8f43d71 100644
--- a/include/grub/kernel.h
+++ b/include/grub/kernel.h
@@ -77,7 +77,7 @@ struct grub_module_info64
 #if defined (GRUB_MACHINE_PCBIOS) || defined (GRUB_MACHINE_COREBOOT) \
   || defined (GRUB_MACHINE_MULTIBOOT) || defined (GRUB_MACHINE_MIPS_QEMU_MIPS) \
   || defined (GRUB_MACHINE_MIPS_LOONGSON) || defined (GRUB_MACHINE_ARC) \
-  || defined (__sparc__)
+  || defined (__sparc__) || defined (GRUB_MACHINE_XEN)
 /* FIXME: stack is between 2 heap regions. Move it.  */
 #define GRUB_KERNEL_PRELOAD_SPACE_REUSABLE 1
 #endif
@@ -113,7 +113,7 @@ void grub_main (void) __attribute__ ((noreturn));
 void grub_machine_init (void);
 
 /* The machine-specific finalization.  */
-void EXPORT_FUNC(grub_machine_fini) (void);
+void EXPORT_FUNC(grub_machine_fini) (int flags);
 
 /* The machine-specific prefix initialization.  */
 void
diff --git a/include/grub/offsets.h b/include/grub/offsets.h
index bce755d..56c679c 100644
--- a/include/grub/offsets.h
+++ b/include/grub/offsets.h
@@ -99,7 +99,12 @@
 #define GRUB_KERNEL_I386_COREBOOT_MOD_ALIGN	0x1
 #define GRUB_KERNEL_I386_MULTIBOOT_MOD_ALIGN	GRUB_KERNEL_I386_COREBOOT_MOD_ALIGN
 
+#define GRUB_KERNEL_X86_64_XEN_MOD_ALIGN	0x8
+#define GRUB_KERNEL_I386_XEN_MOD_ALIGN	0x8
+
 /* Non-zero value is only needed for PowerMacs.  */
+#define GRUB_KERNEL_X86_64_XEN_MOD_GAP 0x0
+#define GRUB_KERNEL_I386_XEN_MOD_GAP 0x0
 #define GRUB_KERNEL_I386_IEEE1275_MOD_GAP 0x0
 #define GRUB_KERNEL_I386_COREBOOT_MOD_GAP 0x0
 #define GRUB_KERNEL_SPARC64_IEEE1275_MOD_GAP 0x0
diff --git a/include/grub/x86_64/xen/hypercall.h b/include/grub/x86_64/xen/hypercall.h
new file mode 100644
index 0000000..780db4d
--- /dev/null
+++ b/include/grub/x86_64/xen/hypercall.h
@@ -0,0 +1,34 @@
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2013  Free Software Foundation, Inc.
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef GRUB_XEN_CPU_HYPERCALL_HEADER
+#define GRUB_XEN_CPU_HYPERCALL_HEADER 1
+
+int EXPORT_FUNC (grub_xen_sched_op) (int cmd, void *arg);
+int grub_xen_update_va_mapping (void *addr, uint64_t pte, uint64_t flags);
+int grub_xen_event_channel_op (int op, void *arg);
+
+int grub_xen_mmuext_op (mmuext_op_t * ops,
+			unsigned int count,
+			unsigned int *pdone, unsigned int foreigndom);
+int EXPORT_FUNC (grub_xen_mmu_update) (const struct mmu_update * reqs,
+				       unsigned count, unsigned *done_out,
+				       unsigned foreigndom);
+int EXPORT_FUNC (grub_xen_grant_table_op) (int, void *, int);
+
+#endif
diff --git a/include/grub/xen.h b/include/grub/xen.h
new file mode 100644
index 0000000..062c95d
--- /dev/null
+++ b/include/grub/xen.h
@@ -0,0 +1,93 @@
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2013  Free Software Foundation, Inc.
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef GRUB_XEN_HEADER
+#define GRUB_XEN_HEADER 1
+
+#define __XEN_INTERFACE_VERSION__ 0x0003020a
+
+#ifdef ASM_FILE
+#define __ASSEMBLY__
+#include <xen/xen.h>
+#else
+
+#include <grub/symbol.h>
+#include <grub/types.h>
+#include <grub/err.h>
+
+#ifndef GRUB_SYMBOL_GENERATOR
+#include <stdint.h>
+#include <xen/xen.h>
+
+#include <xen/sched.h>
+#include <xen/grant_table.h>
+#include <xen/io/console.h>
+#include <xen/io/xs_wire.h>
+#include <xen/io/xenbus.h>
+#include <xen/io/protocols.h>
+#endif
+
+#include <grub/cpu/xen/hypercall.h>
+
+extern grub_size_t EXPORT_VAR (grub_xen_n_allocated_shared_pages);
+
+
+#define GRUB_XEN_LOG_PAGE_SIZE 12
+#define GRUB_XEN_PAGE_SIZE (1 << GRUB_XEN_LOG_PAGE_SIZE)
+
+extern volatile struct xencons_interface *grub_xen_xcons;
+extern volatile struct shared_info *EXPORT_VAR (grub_xen_shared_info);
+extern volatile struct xenstore_domain_interface *grub_xen_xenstore;
+extern volatile grant_entry_v2_t *grub_xen_grant_table;
+
+void EXPORT_FUNC (grub_xen_store_send) (const void *buf_, grub_size_t len);
+void EXPORT_FUNC (grub_xen_store_recv) (void *buf_, grub_size_t len);
+grub_err_t
+EXPORT_FUNC (grub_xenstore_dir) (const char *dir,
+				 int (*hook) (const char *dir,
+					      void *hook_data),
+				 void *hook_data);
+void *EXPORT_FUNC (grub_xenstore_get_file) (const char *dir,
+					    grub_size_t * len);
+grub_err_t EXPORT_FUNC (grub_xenstore_write_file) (const char *dir,
+						   const void *buf,
+						   grub_size_t len);
+
+typedef unsigned int grub_xen_grant_t;
+
+void *EXPORT_FUNC (grub_xen_alloc_shared_page) (domid_t dom,
+						grub_xen_grant_t * grnum);
+void EXPORT_FUNC (grub_xen_free_shared_page) (void *ptr);
+
+#define mb() asm volatile("mfence;sfence;" : : : "memory");
+extern struct start_info *EXPORT_VAR (grub_xen_start_page_addr);
+
+void grub_console_init (void);
+
+void grub_xendisk_fini (void);
+void grub_xendisk_init (void);
+
+#ifdef __x86_64__
+typedef grub_uint64_t grub_xen_mfn_t;
+#else
+typedef grub_uint32_t grub_xen_mfn_t;
+#endif
+typedef unsigned int grub_xen_evtchn_t;
+#endif
+
+#endif
diff --git a/include/grub/xen/relocator.h b/include/grub/xen/relocator.h
new file mode 100644
index 0000000..ae45dce
--- /dev/null
+++ b/include/grub/xen/relocator.h
@@ -0,0 +1,44 @@
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2013  Free Software Foundation, Inc.
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef GRUB_RELOCATOR_XEN_HEADER
+#define GRUB_RELOCATOR_XEN_HEADER	1
+
+#include <grub/types.h>
+#include <grub/err.h>
+#include <grub/relocator.h>
+
+struct grub_relocator_xen_state
+{
+  grub_addr_t start_info;
+  grub_addr_t paging_start;
+  grub_addr_t paging_size;
+  grub_addr_t mfn_list;
+  grub_addr_t stack;
+  grub_addr_t entry_point;
+};
+
+grub_err_t
+grub_relocator_xen_boot (struct grub_relocator *rel,
+			 struct grub_relocator_xen_state state,
+			 grub_uint64_t remapper_pfn,
+			 grub_addr_t remapper_virt,
+			 grub_uint64_t trampoline_pfn,
+			 grub_addr_t trampoline_virt);
+
+#endif
diff --git a/include/grub/xen_file.h b/include/grub/xen_file.h
new file mode 100644
index 0000000..4b2ccba
--- /dev/null
+++ b/include/grub/xen_file.h
@@ -0,0 +1,54 @@
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2013  Free Software Foundation, Inc.
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef GRUB_XEN_FILE_HEADER
+#define GRUB_XEN_FILE_HEADER 1
+
+#include <grub/types.h>
+#include <grub/elf.h>
+#include <grub/elfload.h>
+
+grub_elf_t grub_xen_file (grub_file_t file);
+
+struct grub_xen_file_info
+{
+  grub_uint64_t kern_start, kern_end;
+  grub_uint64_t virt_base;
+  grub_uint64_t entry_point;
+  grub_uint64_t hypercall_page;
+  grub_uint64_t paddr_offset;
+  int has_hypercall_page;
+  int has_note;
+  int has_xen_guest;
+  int extended_cr3;
+  enum
+  {
+    GRUB_XEN_FILE_I386 = 1,
+    GRUB_XEN_FILE_I386_PAE = 2,
+    GRUB_XEN_FILE_I386_PAE_BIMODE = 3,
+    GRUB_XEN_FILE_X86_64 = 4
+  } arch;
+};
+
+grub_err_t
+grub_xen_get_info32 (grub_elf_t elf, struct grub_xen_file_info *xi);
+grub_err_t
+grub_xen_get_info64 (grub_elf_t elf, struct grub_xen_file_info *xi);
+grub_err_t grub_xen_get_info (grub_elf_t elf, struct grub_xen_file_info *xi);
+
+#endif
